#!/bin/bash
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Originally written by Bryant Treacle
# https://raw.githubusercontent.com/bryant-treacle/so-elastalert-test-rule/master/so-elastalert-test
# Modified by Doug Burks
#
# Purpose:  This script will allow you to test your elastalert rule without entering the Docker container.

. /usr/sbin/so-elastic-common


current_rules=$(sudo ls /etc/elastalert/rules/)
echo
echo "This script will allow you to test an Elastalert rule."
echo
echo
echo
echo "Below is a list of active rules in the /etc/elastalert/rules/ directory."
echo 
echo "$current_rules"
echo 
echo "Note: To test a rule it must be accessible by the Elastalert docker container."
echo
echo "Please enter the file path and rule name you want to test."
read -e rulename

echo "The results can be rather long.  Would you like to write the results to a file? (Y/N)"
read -n 1 resultstolog

if [ "$resultstolog" == "n" ]; then
    echo "Please enter the file path and file name."
	read -e filesavelocation
	echo "Depending on the rule this may take a while."
	docker exec -it so-elastalert bash -c "elastalert-test-rule $rulename" > $filesavelocation
else 
    echo "Depending on the rule this may take a while."
    docker exec -it so-elastalert bash -c "elastalert-test-rule $rulename"
fi

echo "Complete!"
